// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VRAS__Syms.h"


//======================

void VRAS::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VRAS::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VRAS::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VRAS::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VRAS::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VRAS__Syms* __restrict vlSymsp = static_cast<VRAS__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VRAS::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VRAS::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VRAS__Syms* __restrict vlSymsp = static_cast<VRAS__Syms*>(userp);
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VRAS::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VRAS__Syms* __restrict vlSymsp = static_cast<VRAS__Syms*>(userp);
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+52,"clk", false,-1);
        tracep->declBit(c+53,"res_n", false,-1);
        tracep->declBit(c+54,"lock", false,-1);
        tracep->declBit(c+55,"unlock", false,-1);
        tracep->declBus(c+56,"key", false,-1, 31,0);
        tracep->declBit(c+57,"in_addr_val", false,-1);
        tracep->declQuad(c+58,"in_addr", false,-1, 47,0);
        tracep->declBit(c+60,"rd", false,-1);
        tracep->declBit(c+61,"out_addr_val", false,-1);
        tracep->declQuad(c+62,"out_addr", false,-1, 47,0);
        tracep->declBit(c+64,"locked", false,-1);
        tracep->declBit(c+65,"ras_write_active", false,-1);
        tracep->declBit(c+66,"empty", false,-1);
        tracep->declBit(c+67,"full", false,-1);
        tracep->declBit(c+52,"RAS clk", false,-1);
        tracep->declBit(c+53,"RAS res_n", false,-1);
        tracep->declBit(c+54,"RAS lock", false,-1);
        tracep->declBit(c+55,"RAS unlock", false,-1);
        tracep->declBus(c+56,"RAS key", false,-1, 31,0);
        tracep->declBit(c+57,"RAS in_addr_val", false,-1);
        tracep->declQuad(c+58,"RAS in_addr", false,-1, 47,0);
        tracep->declBit(c+60,"RAS rd", false,-1);
        tracep->declBit(c+61,"RAS out_addr_val", false,-1);
        tracep->declQuad(c+62,"RAS out_addr", false,-1, 47,0);
        tracep->declBit(c+64,"RAS locked", false,-1);
        tracep->declBit(c+65,"RAS ras_write_active", false,-1);
        tracep->declBit(c+66,"RAS empty", false,-1);
        tracep->declBit(c+67,"RAS full", false,-1);
        tracep->declBus(c+70,"RAS RAS_SIZE", false,-1, 31,0);
        tracep->declBus(c+71,"RAS RAS_WIDTH", false,-1, 31,0);
        tracep->declBus(c+72,"RAS KEY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+73,"RAS KEY", false,-1, 31,0);
        tracep->declQuad(c+74,"RAS ZERO_ADDR", false,-1, 47,0);
        tracep->declBus(c+68,"RAS STATE", false,-1, 0,0);
        tracep->declBus(c+2,"RAS NEXT_STATE", false,-1, 0,0);
        tracep->declBit(c+3,"RAS RAS_STACK_status", false,-1);
        tracep->declBit(c+52,"RAS RAS_STACK_clk", false,-1);
        tracep->declBit(c+53,"RAS RAS_STACK_res_n", false,-1);
        tracep->declBit(c+4,"RAS RAS_STACK_wr", false,-1);
        tracep->declQuad(c+5,"RAS RAS_STACK_wr_data", false,-1, 47,0);
        tracep->declBit(c+7,"RAS RAS_STACK_rd", false,-1);
        tracep->declQuad(c+8,"RAS RAS_STACK_rd_data", false,-1, 47,0);
        tracep->declBit(c+15,"RAS RAS_STACK_empty", false,-1);
        tracep->declBit(c+16,"RAS RAS_STACK_full", false,-1);
        tracep->declBit(c+10,"RAS DO_IDLE", false,-1);
        tracep->declBit(c+11,"RAS DO_LOCK", false,-1);
        tracep->declBit(c+12,"RAS DO_READ_STACK", false,-1);
        tracep->declBit(c+13,"RAS DO_UNLOCK", false,-1);
        tracep->declBit(c+14,"RAS DO_WRITE_STACK", false,-1);
        tracep->declBit(c+69,"RAS IS_KEY_MATCH", false,-1);
        tracep->declBus(c+76,"RAS RAS_STACK data_width", false,-1, 31,0);
        tracep->declBus(c+77,"RAS RAS_STACK num_of_entries", false,-1, 31,0);
        tracep->declBus(c+78,"RAS RAS_STACK addr_width", false,-1, 31,0);
        tracep->declBit(c+52,"RAS RAS_STACK clk", false,-1);
        tracep->declBit(c+53,"RAS RAS_STACK res_n", false,-1);
        tracep->declBit(c+7,"RAS RAS_STACK rd", false,-1);
        tracep->declBit(c+4,"RAS RAS_STACK wr", false,-1);
        tracep->declQuad(c+5,"RAS RAS_STACK wr_data", false,-1, 47,0);
        tracep->declQuad(c+8,"RAS RAS_STACK rd_data", false,-1, 47,0);
        tracep->declBit(c+15,"RAS RAS_STACK empty", false,-1);
        tracep->declBit(c+16,"RAS RAS_STACK full", false,-1);
        tracep->declBus(c+79,"RAS RAS_STACK ZERO_ADDR", false,-1, 3,0);
        tracep->declQuad(c+74,"RAS RAS_STACK ZERO_DATA", false,-1, 47,0);
        {int i; for (i=0; i<16; i++) {
                tracep->declQuad(c+17+i*2,"RAS RAS_STACK MEMORY", true,(i+0), 47,0);}}
        tracep->declBus(c+49,"RAS RAS_STACK HEAD", false,-1, 3,0);
        tracep->declBus(c+50,"RAS RAS_STACK HEAD_PLUS_1", false,-1, 3,0);
        tracep->declBus(c+51,"RAS RAS_STACK HEAD_MINUS_1", false,-1, 3,0);
        tracep->declBus(c+1,"RAS RAS_STACK i", false,-1, 31,0);
    }
}

void VRAS::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VRAS::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VRAS__Syms* __restrict vlSymsp = static_cast<VRAS__Syms*>(userp);
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VRAS::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VRAS__Syms* __restrict vlSymsp = static_cast<VRAS__Syms*>(userp);
    VRAS* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->RAS__DOT__RAS_STACK__DOT__i),32);
        tracep->fullBit(oldp+2,(vlTOPp->RAS__DOT__NEXT_STATE));
        tracep->fullBit(oldp+3,(vlTOPp->RAS__DOT__RAS_STACK_status));
        tracep->fullBit(oldp+4,(vlTOPp->RAS__DOT__RAS_STACK_wr));
        tracep->fullQData(oldp+5,(vlTOPp->RAS__DOT__RAS_STACK_wr_data),48);
        tracep->fullBit(oldp+7,(vlTOPp->RAS__DOT__RAS_STACK_rd));
        tracep->fullQData(oldp+8,(vlTOPp->RAS__DOT__RAS_STACK_rd_data),48);
        tracep->fullBit(oldp+10,(vlTOPp->RAS__DOT__DO_IDLE));
        tracep->fullBit(oldp+11,(vlTOPp->RAS__DOT__DO_LOCK));
        tracep->fullBit(oldp+12,(vlTOPp->RAS__DOT__DO_READ_STACK));
        tracep->fullBit(oldp+13,(vlTOPp->RAS__DOT__DO_UNLOCK));
        tracep->fullBit(oldp+14,(vlTOPp->RAS__DOT__DO_WRITE_STACK));
        tracep->fullBit(oldp+15,((0U == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
        tracep->fullBit(oldp+16,((0xfU == (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD))));
        tracep->fullQData(oldp+17,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[0]),48);
        tracep->fullQData(oldp+19,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[1]),48);
        tracep->fullQData(oldp+21,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[2]),48);
        tracep->fullQData(oldp+23,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[3]),48);
        tracep->fullQData(oldp+25,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[4]),48);
        tracep->fullQData(oldp+27,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[5]),48);
        tracep->fullQData(oldp+29,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[6]),48);
        tracep->fullQData(oldp+31,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[7]),48);
        tracep->fullQData(oldp+33,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[8]),48);
        tracep->fullQData(oldp+35,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[9]),48);
        tracep->fullQData(oldp+37,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[10]),48);
        tracep->fullQData(oldp+39,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[11]),48);
        tracep->fullQData(oldp+41,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[12]),48);
        tracep->fullQData(oldp+43,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[13]),48);
        tracep->fullQData(oldp+45,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[14]),48);
        tracep->fullQData(oldp+47,(vlTOPp->RAS__DOT__RAS_STACK__DOT__MEMORY[15]),48);
        tracep->fullCData(oldp+49,(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD),4);
        tracep->fullCData(oldp+50,((0xfU & ((IData)(1U) 
                                            + (IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD)))),4);
        tracep->fullCData(oldp+51,((0xfU & ((IData)(vlTOPp->RAS__DOT__RAS_STACK__DOT__HEAD) 
                                            - (IData)(1U)))),4);
        tracep->fullBit(oldp+52,(vlTOPp->clk));
        tracep->fullBit(oldp+53,(vlTOPp->res_n));
        tracep->fullBit(oldp+54,(vlTOPp->lock));
        tracep->fullBit(oldp+55,(vlTOPp->unlock));
        tracep->fullIData(oldp+56,(vlTOPp->key),32);
        tracep->fullBit(oldp+57,(vlTOPp->in_addr_val));
        tracep->fullQData(oldp+58,(vlTOPp->in_addr),48);
        tracep->fullBit(oldp+60,(vlTOPp->rd));
        tracep->fullBit(oldp+61,(vlTOPp->out_addr_val));
        tracep->fullQData(oldp+62,(vlTOPp->out_addr),48);
        tracep->fullBit(oldp+64,(vlTOPp->locked));
        tracep->fullBit(oldp+65,(vlTOPp->ras_write_active));
        tracep->fullBit(oldp+66,(vlTOPp->empty));
        tracep->fullBit(oldp+67,(vlTOPp->full));
        tracep->fullBit(oldp+68,(vlTOPp->RAS__DOT__STATE));
        tracep->fullBit(oldp+69,((0xdeadbeefU == vlTOPp->key)));
        tracep->fullIData(oldp+70,(0x10U),32);
        tracep->fullIData(oldp+71,(0x30U),32);
        tracep->fullIData(oldp+72,(0x20U),32);
        tracep->fullIData(oldp+73,(0xdeadbeefU),32);
        tracep->fullQData(oldp+74,(0ULL),48);
        tracep->fullIData(oldp+76,(0x30U),32);
        tracep->fullIData(oldp+77,(0x10U),32);
        tracep->fullIData(oldp+78,(4U),32);
        tracep->fullCData(oldp+79,(0U),4);
    }
}
